/*
 * Copyright (C) 2021 Parisi Alessandro
 * This file is part of MaterialFX (https://github.com/palexdev/MaterialFX).
 *
 * MaterialFX is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MaterialFX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with MaterialFX.  If not, see <http://www.gnu.org/licenses/>.
 */

package io.github.palexdev.materialfx.font;

/**
 * Enumerator class for MaterialFX font resources. (Count: 95)
 */
public enum FontResources {
    ANGLE_DOWN("mfx-angle-down", '\uE900'),
    ANGLE_LEFT("mfx-angle-left", '\uE901'),
    ANGLE_RIGHT("mfx-angle-right", '\uE902'),
    ANGLE_UP("mfx-angle-up", '\uE903'),
    ARROW_BACK("mfx-arrow-back", '\uE904'),
    ARROW_FORWARD("mfx-arrow-forward", '\uE905'),
    BACK("mfx-back", '\uE906'),
    CALENDAR_BLACK("mfx-calendar-black", '\uE907'),
    CALENDAR_SEMI_BLACK("mfx-calendar-semi-black", '\uE908'),
    CALENDAR_WHITE("mfx-calendar-white", '\uE909'),
    CARET_DOWN("mfx-caret-down", '\uE90A'),
    CARET_LEFT("mfx-caret-left", '\uE90B'),
    CARET_RIGHT("mfx-caret-right", '\uE90C'),
    CARET_UP("mfx-caret-up", '\uE90D'),
    CASPIAN_MARK("mfx-caspian-mark", '\uE90E'),
    CHART_PIE("mfx-chart-pie", '\uE90F'),
    CHECK_CIRCLE("mfx-check-circle", '\uE910'),
    CHEVRON_DOWN("mfx-chevron-down", '\uE911'),
    CHEVRON_LEFT("mfx-chevron-left", '\uE912'),
    CHEVRON_RIGHT("mfx-chevron-right", '\uE913'),
    CHEVRON_UP("mfx-chevron-up", '\uE914'),
    CIRCLE("mfx-circle", '\uE915'),
    CONTENT_COPY("mfx-content-copy", '\uE916'),
    CONTENT_CUT("mfx-content-cut", '\uE917'),
    CONTENT_PASTE("mfx-content-paste", '\uE918'),
    DASHBOARD("mfx-dashboard", '\uE919'),
    DEBUG("mfx-debug", '\uE91A'),
    DELETE("mfx-delete", '\uE91B'),
    DELETE_ALT("mfx-delete-alt", '\uE91C'),
    EXCLAMATION_CIRCLE("mfx-exclamation-circle", '\uE91D'),
    EXCLAMATION_TRIANGLE("mfx-exclamation-triangle", '\uE91E'),
    EXPAND("mfx-expand", '\uE91F'),
    EYE("mfx-eye", '\uE920'),
    EYE_SLASH("mfx-eye-slash", '\uE921'),
    FILE("mfx-file", '\uE922'),
    FILTER("mfx-filter", '\uE923'),
    FILTER_ALT("mfx-filter-alt", '\uE924'),
    FILTER_ALT_CLEAR("mfx-filter-alt-clear", '\uE925'),
    FIRST_PAGE("mfx-first-page", '\uE926'),
    FIT("mfx-fit", '\uE927'),
    FOLDER("mfx-folder", '\uE928'),
    GEAR("mfx-gear", '\uE929'),
    GOOGLE("mfx-google", '\uE92A'),
    GOOGLE_DRAWING("mfx-google-drawing", '\uE92B'),
    GOOGLE_DRIVE("mfx-google-drive", '\uE92C'),
    GOOGLE_FORMS("mfx-google-forms", '\uE92D'),
    GOOGLE_FUSION_TABLES("mfx-google-fusion-tables", '\uE92E'),
    GOOGLE_PRESENTATION("mfx-google-presentation", '\uE92F'),
    GOOGLE_SCRIPT("mfx-google-script", '\uE930'),
    GOOGLE_SITES("mfx-google-sites", '\uE931'),
    HOME("mfx-home", '\uE932'),
    IMAGE("mfx-image", '\uE933'),
    INFO("mfx-info", '\uE934'),
    INFO_CIRCLE("mfx-info-circle", '\uE935'),
    LAST_PAGE("mfx-last-page", '\uE936'),
    LEVEL_UP("mfx-level-up", '\uE937'),
    LOCK("mfx-lock", '\uE938'),
    LOCK_OPEN("mfx-lock-open", '\uE939'),
    MAP("mfx-map", '\uE93A'),
    MINUS("mfx-minus", '\uE93B'),
    MINUS_CIRCLE("mfx-minus-circle", '\uE93C'),
    MODENA_MARK("mfx-modena-mark", '\uE93D'),
    MUSIC("mfx-music", '\uE93E'),
    NEXT("mfx-next", '\uE93F'),
    REDO("mfx-redo", '\uE940'),
    RESTORE("mfx-restore", '\uE941'),
    SEARCH("mfx-search", '\uE942'),
    SEARCH_PLUS("mfx-search-plus", '\uE943'),
    SELECT_ALL("mfx-select-all", '\uE944'),
    SHORTCUT("mfx-shortcut", '\uE945'),
    SLIDERS("mfx-sliders", '\uE946'),
    SPREADSHEET("mfx-spreadsheet", '\uE947'),
    STEP_BACKWARD("mfx-step-backward", '\uE948'),
    STEP_FORWARD("mfx-step-forward", '\uE949'),
    SYNC("mfx-sync", '\uE94A'),
    SYNC_LIGHT("mfx-sync-light", '\uE94B'),
    UNDO("mfx-undo", '\uE94C'),
    USER("mfx-user", '\uE94D'),
    USERS("mfx-users", '\uE94E'),
    VARIANT10_MARK("mfx-variant10-mark", '\uE94F'),
    VARIANT11_MARK("mfx-variant11-mark", '\uE950'),
    VARIANT12_MARK("mfx-variant12-mark", '\uE951'),
    VARIANT3_MARK("mfx-variant3-mark", '\uE952'),
    VARIANT4_MARK("mfx-variant4-mark", '\uE953'),
    VARIANT5_MARK("mfx-variant5-mark", '\uE954'),
    VARIANT6_MARK("mfx-variant6-mark", '\uE955'),
    VARIANT7_MARK("mfx-variant7-mark", '\uE956'),
    VARIANT8_MARK("mfx-variant8-mark", '\uE957'),
    VARIANT9_MARK("mfx-variant9-mark", '\uE958'),
    VIDEO("mfx-video", '\uE959'),
    X("mfx-x", '\uE95A'),
    X_ALT("mfx-x-alt", '\uE95B'),
    X_CIRCLE("mfx-x-circle", '\uE95C'),
    X_CIRCLE_LIGHT("mfx-x-circle-light", '\uE95D'),
    X_LIGHT("mfx-x-light", '\uE95E'),
    ;

    public static FontResources findByDescription(String description) {
        for (FontResources font : values()) {
            if (font.getDescription().equals(description)) {
                return font;
            }
        }
        throw new IllegalArgumentException("Icon description '" + description + "' is invalid!");
    }

    private final String description;
    private final char code;

    FontResources(String description, char code) {
        this.description = description;
        this.code = code;
    }

    public String getDescription() {
        return description;
    }

    public char getCode() {
        return code;
    }

}
